Index: palm/trunk/SOURCE/radiation_model.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model.f90	(revision 1539)
+++ palm/trunk/SOURCE/radiation_model.f90	(revision 1551)
@@ -20,5 +20,7 @@
 ! Current revisions:
 ! -----------------
-! 
+! Added support for data output. Various variables have been renamed. Added
+! interface for different radiation schemes (currently: clear-sky, constant, and
+! RRTM (not yet implemented).
 ! 
 ! Former revisions:
@@ -46,11 +48,18 @@
     USE kinds
 
+    USE netcdf_control,                                                        &
+        ONLY:  dots_label, dots_num, dots_unit
+
 
     IMPLICIT NONE
 
+    CHARACTER(10) :: radiation_scheme = 'clear-sky' ! 'constant', 'clear-sky', or 'rrtm'
+
     INTEGER(iwp) :: i, j, k
 
 
-    INTEGER(iwp) :: day_init = 1 !: day of the year at model start
+    INTEGER(iwp) :: day_init     = 172,  & !: day of the year at model start (21/06)
+                    dots_rad     = 0,    & !: starting index for timeseries output 
+                    irad_scheme  = 0
 
     LOGICAL :: radiation = .FALSE.  !: flag parameter indicating wheather the radiation model is used
@@ -61,5 +70,5 @@
  
     REAL(wp) :: albedo = 0.2_wp,             & !: NAMELIST alpha
-                dt_radiation = 9999999.9_wp, &
+                dt_radiation = 0.0_wp,       & !: radiation model timestep
                 exn,                         & !: Exner function
                 lon = 0.0_wp,                & !: longitude in radians
@@ -69,8 +78,9 @@
                 decl_3,                      & !: declination coef. 3
                 time_utc,                    & !: current time in UTC
-                time_utc_init = 0.0_wp,      & !: UTC time at model start
+                time_utc_init = 43200.0_wp,  & !: UTC time at model start (noon)
                 day,                         & !: current day of the year
                 lambda = 0.0_wp,             & !: longitude in degrees
                 declination,                 & !: solar declination angle
+                net_radiation = 0.0_wp,      & !: net radiation at surface
                 hour_angle,                  & !: solar hour angle
                 time_radiation = 0.0_wp,     &
@@ -80,9 +90,11 @@
     REAL(wp), DIMENSION(:,:), ALLOCATABLE :: &
                 alpha,                       & !: surface albedo
-                Rn,                          & !: net radiation at the surface
-                LW_in,                       & !: incoming longwave radiation
-                LW_out,                      & !: outgoing longwave radiation
-                SW_in,                       & !: incoming shortwave radiation
-                SW_out                         !: outgoing shortwave radiation
+                rad_net,                     & !: net radiation at the surface
+                rad_net_av,                  & !: average of rad_net
+                rad_lw_in,                   & !: incoming longwave radiation
+                rad_lw_out,                  & !: outgoing longwave radiation
+                rad_sw_in,                   & !: incoming shortwave radiation
+                rad_sw_in_av,                & !: average of rad_sw_in
+                rad_sw_out                     !: outgoing shortwave radiation
 
 
@@ -91,7 +103,16 @@
     END INTERFACE init_radiation
 
-    INTERFACE lsm_radiation
-       MODULE PROCEDURE lsm_radiation
-    END INTERFACE lsm_radiation
+    INTERFACE radiation_clearsky
+       MODULE PROCEDURE radiation_clearsky
+    END INTERFACE radiation_clearsky
+
+    INTERFACE radiation_constant
+       MODULE PROCEDURE radiation_constant
+    END INTERFACE radiation_constant
+
+    INTERFACE radiation_rrtm
+       MODULE PROCEDURE radiation_rrtm
+    END INTERFACE radiation_rrtm
+
 
     SAVE
@@ -99,7 +120,9 @@
     PRIVATE
 
-    PUBLIC albedo, day_init, dt_radiation, init_radiation, lambda,             &
-           lsm_radiation, Rn, radiation, SW_in, sigma_SB, time_radiation,      &
-           time_utc_init 
+    PUBLIC albedo, day_init, dots_rad, dt_radiation, init_radiation,           &
+           irad_scheme, lambda, net_radiation, rad_net, rad_net_av, radiation, &
+           radiation_clearsky, radiation_constant, radiation_rrtm,             &
+           radiation_scheme, rad_sw_in, rad_sw_in_av, sigma_SB,                &
+           time_radiation, time_utc_init 
 
 
@@ -118,22 +141,41 @@
 
        ALLOCATE ( alpha(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( Rn(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( LW_in(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( LW_out(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( SW_in(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( SW_out(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( rad_net(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( rad_lw_in(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( rad_lw_out(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( rad_sw_in(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( rad_sw_out(nysg:nyng,nxlg:nxrg) )
+
+       rad_sw_in  = 0.0_wp
+       rad_sw_out = 0.0_wp
+       rad_lw_in  = 0.0_wp
+       rad_lw_out = 0.0_wp
+       rad_net    = 0.0_wp
 
        alpha = albedo
 
 !
+!--    Fix net radiation in case of radiation_scheme = 'constant'
+       IF ( irad_scheme == 0 )  THEN
+          rad_net = net_radiation
+!
 !--    Calculate radiation scheme constants
-       decl_1 = SIN(23.45_wp * pi / 180.0_wp)
-       decl_2 = 2.0 * pi / 365.0_wp
-       decl_3 = decl_2 * 81.0_wp
-
-!
-!--    Calculate latitude and longitude angles (lat and lon, respectively)
-       lat = phi * pi / 180.0_wp
-       lon = lambda * pi / 180.0_wp
+       ELSEIF ( irad_scheme == 1 .OR. irad_scheme == 2 )  THEN
+          decl_1 = SIN(23.45_wp * pi / 180.0_wp)
+          decl_2 = 2.0_wp * pi / 365.0_wp
+          decl_3 = decl_2 * 81.0_wp
+!
+!--       Calculate latitude and longitude angles (lat and lon, respectively)
+          lat = phi * pi / 180.0_wp
+          lon = lambda * pi / 180.0_wp
+       ENDIF
+!
+!--    Add timeseries for radiation model
+       dots_label(dots_num+1) = "rad_net"
+       dots_label(dots_num+2) = "rad_sw_in"
+       dots_unit(dots_num+1:dots_num+2) = "W/m2"
+
+       dots_rad  = dots_num + 1
+       dots_num  = dots_num + 2
 
        RETURN
@@ -147,5 +189,5 @@
 !-- A simple clear sky radiation model
 !------------------------------------------------------------------------------!
-    SUBROUTINE lsm_radiation
+    SUBROUTINE radiation_clearsky
     
 
@@ -167,5 +209,5 @@
 !
 !--    Calculate zenith angle
-       zenith = SIN(lat)*SIN(declination) + COS(lat) * COS(declination)        &
+       zenith = SIN(lat) * SIN(declination) + COS(lat) * COS(declination)       &
                                             * COS(hour_angle)
        zenith = MAX(0.0_wp,zenith)
@@ -180,14 +222,16 @@
 
 !
-!--    Calculate radiation fluxes and net radiation (Rn) for each grid point
+!--    Calculate radiation fluxes and net radiation (rad_net) for each grid 
+!--    point
        DO i = nxlg, nxrg
           DO j = nysg, nyng
 
              k = nzb_s_inner(j,i)
-             SW_in(j,i)  = SW_0 * sky_trans * zenith
-             SW_out(j,i) = - alpha(j,i) * SW_in(j,i)
-             LW_out(j,i) = - sigma_SB * (pt(k,j,i) * exn)**4
-             LW_in(j,i)  = 0.8 * sigma_SB * (pt(k+1,j,i) * exn)**4
-             Rn(j,i)     = SW_in(j,i) + SW_out(j,i) + LW_in(j,i) + LW_out(j,i)
+             rad_sw_in(j,i)  = SW_0 * sky_trans * zenith
+             rad_sw_out(j,i) = - alpha(j,i) * rad_sw_in(j,i)
+             rad_lw_out(j,i) = - sigma_SB * (pt(k,j,i) * exn)**4
+             rad_lw_in(j,i)  = 0.8_wp * sigma_SB * (pt(k+1,j,i) * exn)**4
+             rad_net(j,i)    = rad_sw_in(j,i) + rad_sw_out(j,i)                &
+                                + rad_lw_in(j,i) + rad_lw_out(j,i)
 
           ENDDO
@@ -196,7 +240,26 @@
        RETURN
 
-    END SUBROUTINE lsm_radiation
-
-
+    END SUBROUTINE radiation_clearsky
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!-- Prescribed net radiation
+!------------------------------------------------------------------------------!
+    SUBROUTINE radiation_constant
+
+       rad_net = net_radiation
+
+    END SUBROUTINE radiation_constant
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!-- Implementation of the RRTM radiation_scheme
+!------------------------------------------------------------------------------!
+    SUBROUTINE radiation_rrtm
+
+
+    END SUBROUTINE radiation_rrtm
 
  END MODULE radiation_model_mod
Index: palm/trunk/SOURCE/read_3d_binary.f90
===================================================================
--- palm/trunk/SOURCE/read_3d_binary.f90	(revision 1539)
+++ palm/trunk/SOURCE/read_3d_binary.f90	(revision 1551)
@@ -20,5 +20,7 @@
 ! Current revisions:
 ! -----------------
-! 
+! Added support for binary input of land surface and radiation model data. In the
+! course of this work, new temporary arrays tmp_3d_soil1, tmp_3d_soil2 were
+! required.
 ! 
 ! Former revisions:
@@ -94,8 +96,17 @@
     USE kinds
 
+    USE land_surface_model_mod,                                                &
+        ONLY:  c_liq_av, c_soil_av, c_veg, c_veg_av, ghf_eb_av, lai_av,        &
+               qsws_eb_av, qsws_liq_eb_av, qsws_soil_eb_av, qsws_veg_eb_av,    & 
+               land_surface, m_liq_eb, m_liq_eb_av, m_soil, m_soil_av,         &
+               nzb_soil, nzt_soil, shf_eb_av, t_soil, t_soil_av
+
     USE particle_attributes,                                                   &
         ONLY:  iran_part
 
     USE pegrid
+
+    USE radiation_model_mod,                                                   &
+        ONLY: rad_net_av, rad_sw_in_av
 
     USE random_function_mod,                                                   &
@@ -157,18 +168,20 @@
     REAL(wp) ::  rdummy
 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE     ::  tmp_2d     !:
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3d     !:
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3dwul  !:
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3dwun  !:
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3dwur  !:
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3dwus  !:
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3dwvl  !:
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3dwvn  !:
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3dwvr  !:
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3dwvs  !:
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3dwwl  !:
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3dwwn  !:
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3dwwr  !:
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3dwws  !:
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE     ::  tmp_2d      !: temporary array for storing 2D data
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3d      !: temporary array for storing 3D data
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3d_soil1!: temporary array for storing 3D soil model data
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3d_soil2!: temporary array for storing 3D soil model data
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3dwul   !:
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3dwun   !:
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3dwur   !:
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3dwus   !:
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3dwvl   !:
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3dwvn   !:
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3dwvr   !:
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3dwvs   !:
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3dwwl   !:
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3dwwn   !:
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3dwwr   !:
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_3dwws   !:
 
     REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  tmp_4d     !:
@@ -317,5 +330,5 @@
 !--    First compare the version numbers
        READ ( 13 )  version_on_file
-       binary_version = '3.4'
+       binary_version = '4.0'
        IF ( TRIM( version_on_file ) /= TRIM( binary_version ) )  THEN
           WRITE( message_string, * ) 'version mismatch concerning data ',      &
@@ -387,9 +400,20 @@
 !
 !--    Allocate temporary arrays sized as the arrays on the restart file
-       ALLOCATE( tmp_2d(nys_on_file-nbgp:nyn_on_file+nbgp,           &
-                        nxl_on_file-nbgp:nxr_on_file+nbgp),          &
-                 tmp_3d(nzb:nzt+1,nys_on_file-nbgp:nyn_on_file+nbgp, &
+       ALLOCATE( tmp_2d(nys_on_file-nbgp:nyn_on_file+nbgp,                     &
+                        nxl_on_file-nbgp:nxr_on_file+nbgp),                    &
+                 tmp_3d(nzb:nzt+1,nys_on_file-nbgp:nyn_on_file+nbgp,           &
                         nxl_on_file-nbgp:nxr_on_file+nbgp) )
 
+!
+!--    If the land surface model is used, allocate array for storing soil model
+!--    data
+       IF ( land_surface )  THEN
+          ALLOCATE( tmp_3d_soil1(nzb_soil:nzt_soil+1,                          &
+                                nys_on_file-nbgp:nyn_on_file+nbgp,             &
+                                nxl_on_file-nbgp:nxr_on_file+nbgp) )
+          ALLOCATE( tmp_3d_soil2(nzb_soil:nzt_soil,                            &
+                                nys_on_file-nbgp:nyn_on_file+nbgp,             &
+                                nxl_on_file-nbgp:nxr_on_file+nbgp) )
+       ENDIF
 !
 !--    Read arrays
@@ -423,4 +447,28 @@
              SELECT CASE ( TRIM( field_chr ) )
 
+                CASE ( 'c_liq_av' )
+                   IF ( .NOT. ALLOCATED( c_liq_av ) )  THEN
+                      ALLOCATE( c_liq_av(nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   c_liq_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                                  tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'c_soil_av' )
+                   IF ( .NOT. ALLOCATED( c_soil_av ) )  THEN
+                      ALLOCATE( c_soil_av(nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   c_soil_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                                  tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'c_veg_av' )
+                   IF ( .NOT. ALLOCATED( c_veg_av ) )  THEN
+                      ALLOCATE( c_veg_av(nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   c_veg_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                                  tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
                 CASE ( 'e' )
                    IF ( k == 1 )  READ ( 13 )  tmp_3d
@@ -436,8 +484,24 @@
                             tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
+                CASE ( 'ghf_eb_av' )
+                   IF ( .NOT. ALLOCATED( ghf_eb_av ) )  THEN
+                      ALLOCATE( ghf_eb_av(nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   ghf_eb_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                                  tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
                 CASE ( 'iran' ) ! matching random numbers is still unresolved
                                 ! issue
                    IF ( k == 1 )  READ ( 13 )  iran, iran_part
 
+                CASE ( 'lai_av' )
+                   IF ( .NOT. ALLOCATED( lai_av ) )  THEN
+                      ALLOCATE( lai_av(nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   lai_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                                  tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
                 CASE ( 'kh' )
                    IF ( k == 1 )  READ ( 13 )  tmp_3d
@@ -465,4 +529,31 @@
                    lwp_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
                                   tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'm_liq_eb' )
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   m_liq_eb(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  =        &
+                                 tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                CASE ( 'm_liq_eb_av' )
+                   IF ( .NOT. ALLOCATED( m_liq_eb_av ) )  THEN
+                      ALLOCATE( m_liq_eb_av(nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   m_liq_eb_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =      &
+                                  tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'm_soil' )
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d_soil2(:,:,:)
+                   m_soil(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =         &
+                          tmp_3d_soil2(nzb_soil:nzt_soil,nysf-nbgp:nynf        &
+                          +nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'm_soil_av' )
+                   IF ( .NOT. ALLOCATED( m_soil_av ) )  THEN
+                      ALLOCATE( m_soil_av(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d_soil2(:,:,:)
+                   m_soil_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =      &
+                                    tmp_3d_soil2(nzb_soil:nzt_soil,nysf        &
+                                    -nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'nr' )
@@ -679,4 +770,35 @@
                                           tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
+                CASE ( 'qsws_eb_av' )
+                   IF ( .NOT. ALLOCATED( qsws_eb_av ) )  THEN
+                      ALLOCATE( qsws_eb_av(nysg:nyng,nxlg:nxrg) )
+                   ENDIF  
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   qsws_eb_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'qsws_liq_eb_av' )
+                   IF ( .NOT. ALLOCATED( qsws_liq_eb_av ) )  THEN
+                      ALLOCATE( qsws_liq_eb_av(nysg:nyng,nxlg:nxrg) )
+                   ENDIF  
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   qsws_liq_eb_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                CASE ( 'qsws_soil_eb_av' )
+                   IF ( .NOT. ALLOCATED( qsws_soil_eb_av ) )  THEN
+                      ALLOCATE( qsws_soil_eb_av(nysg:nyng,nxlg:nxrg) )
+                   ENDIF  
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   qsws_soil_eb_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'qsws_veg_eb_av' )
+                   IF ( .NOT. ALLOCATED( qsws_veg_eb_av ) )  THEN
+                      ALLOCATE( qsws_veg_eb_av(nysg:nyng,nxlg:nxrg) )
+                   ENDIF  
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   qsws_veg_eb_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
                 CASE ( 'qv_av' )
                    IF ( .NOT. ALLOCATED( qv_av ) )  THEN
@@ -686,4 +808,20 @@
                    qv_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
                              tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'rad_net_av' )
+                   IF ( .NOT. ALLOCATED( rad_net_av ) )  THEN
+                      ALLOCATE( rad_net_av(nysg:nyng,nxlg:nxrg) )
+                   ENDIF  
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   rad_net_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'rad_sw_in_av' )
+                   IF ( .NOT. ALLOCATED( rad_sw_in_av ) )  THEN
+                      ALLOCATE( rad_sw_in_av(nysg:nyng,nxlg:nxrg) )
+                   ENDIF  
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   rad_sw_in_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'random_iv' )  ! still unresolved issue
@@ -759,4 +897,12 @@
                    IF ( k == 1 )  READ ( 13 )  tmp_2d
                    shf_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                         tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'shf_eb_av' )
+                   IF ( .NOT. ALLOCATED( shf_eb_av ) )  THEN
+                      ALLOCATE( shf_eb_av(nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   shf_eb_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
@@ -808,4 +954,19 @@
                    tswst(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 't_soil' )
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d_soil1
+                   t_soil(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =         &
+                                   tmp_3d_soil1(:,nysf-nbgp:nynf+nbgp,         &
+                                                nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 't_soil_av' )
+                   IF ( .NOT. ALLOCATED( t_soil_av ) )  THEN
+                      ALLOCATE( t_soil_av(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d_soil2(:,:,:)
+                   t_soil_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =      &
+                                    tmp_3d_soil2(:,nysf-nbgp:nynf+nbgp,        &
+                                    nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'u' )
@@ -1085,4 +1246,6 @@
 
        DEALLOCATE( tmp_2d, tmp_3d )
+       IF ( ALLOCATED( tmp_3d_soil1 ) )  DEALLOCATE( tmp_3d_soil1 )
+       IF ( ALLOCATED( tmp_3d_soil2 ) )  DEALLOCATE( tmp_3d_soil2 )
 
     ENDDO  ! loop over restart files
Index: palm/trunk/SOURCE/read_var_list.f90
===================================================================
--- palm/trunk/SOURCE/read_var_list.f90	(revision 1539)
+++ palm/trunk/SOURCE/read_var_list.f90	(revision 1551)
@@ -724,5 +724,5 @@
 ! ------------
 ! Skipping the global control variables from restart-file (binary format)
-! except some informations needed when reading restart data from a previous
+! except some information needed when reading restart data from a previous
 ! run which used a smaller total domain or/and a different domain decomposition.
 !------------------------------------------------------------------------------!
